//  File:  memory.h

//  Copyright:  2005, Tres Melton (until I submit it to mej@Eterm)

#ifndef MEMORY_H
#define MEMORY_H 1

typedef struct Aligned_memory
{
  int alignment; 
  void *orig_ptr; 
  void *align_ptr;
  struct Aligned_memory *prev;
  struct Aligned_memory *next;
}aligned_memory;

typedef struct Aligned_mem_list
{
  int number;
  aligned_memory *head;
  aligned_memory *tail;
}aligned_mem_list;

extern void* malloc_aligned( const size_t size, const size_t alignment );
extern void free_aligned( void *ptr );
extern aligned_mem_list amem_list;

#endif
